{-# LANGUAGE NoMonomorphismRestriction #-}

module Lib(acc,acc2,lp1,vsum) where

import Siso
import Data
import Prelude hiding ((.), id)
import Control.Category
import Vec

-- Most primitives's state can be initialized to 0.
sys0 = Sys zero

-- Simple accumulator
acc  = sys0 $ \s i -> do; a <- add s i; return (a, a)
acc2 = acc . acc

-- Many of these return the state as output
rets x = return (x, x)

-- It would be nice to have nested expressions.  Try with
-- using TemplateHaskell.
lp1 = sys0 $ \s (i, a)  -> do
  d  <- sub i s
  ad <- mul a d
  o  <- add s ad
  rets o


-- Free-running damped exponential, quadrature output.
qosc = Sys (one,zero) $ \(sx, sy) (c,s) -> do
  csx <- mul c sx
  ssy <- mul s sy
  sx' <- sub csx ssy
  ssx <- mul s sx
  csy <- mul c sy
  sy' <- add ssx csy
  rets (sx', sy')


vsum = vfold add zero
