{-# LANGUAGE NoMonomorphismRestriction, FlexibleInstances, UndecidableInstances, MultiParamTypeClasses #-}

module Test where

import Siso -- (Compilable) State space model abstraction
import Data -- Siso is independent of the data language.
import Lib  -- Functions written in DSL
import Eval -- Haskell Evaluation DSL semantics
import Code -- Code generator DSL semantics

import Prelude hiding ((.), id)
import Control.Category
import Control.Arrow


-- Shortcuts for specifying Sys Comp types.
type CI   = Code Tint
type CR   = Code Treal
type SysC = Sys Comp
type CiI  = SysC CI CI
type CiII = SysC CI (CI, CI)
type CrR  = SysC CR CR
type CrrR = SysC (CR,CR) CR

dup  = arr $ \x -> (x,x)

evalTest_i   sys = evalSys sys [1,1,1,1,1::Tint]
compTest_iI  sys = compSys initState (sys :: CiI)
compTest_rR  sys = compSys initState (sys :: CrR)
compTest_rrR sys = compSys initState (sys :: CrrR)

info name obj =
  putStrLn $ "\n-- " ++ name ++ ":\n" ++ (show obj)

cvsum :: Sys Comp (Code (CVec Tint)) (Code Tint)
cvsum = sys vsum


main = do
  info "evalSys acc i"   $ evalTest_i acc
  info "compSys acc iI"  $ compTest_iI acc
  info "compSys lp1 rrR" $ compTest_rrR lp1
  info "eval vsum 1,2,3" $ eval $ vsum $ Val $ VVal [1,2,3::Int]
  info "compSys vsym"    $ compSys initState cvsum


