{-# LANGUAGE MultiParamTypeClasses, FlexibleInstances, ScopedTypeVariables,
FlexibleContexts, KindSignatures #-}

module Vec(Vec(..)
          ,VecFold(..)
          ,VecMap(..)) where
import Data
import Type

-- Note: 'r' is always the outer type constructor wrt. 'v'.
-- And 'm' is outer wrt. 'r'.

class Vec (v :: * -> *)

class (Vec v, Data m r) => VecMap v m r a b where
  vmap :: (r a -> m (r b)) ->
          r (v a) ->
          r (v b)

class (Vec v, Data m r) => VecFold v m r e a where
  vfold :: (r e -> r a -> m (r a)) ->
           r a ->
           r (v e) ->
           m (r a)

